/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.23
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE PACKAGE
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#ifdef PACKAGE_NAME
#define CMDLINE_PARSER_PACKAGE_NAME PACKAGE_NAME
#else
#define CMDLINE_PARSER_PACKAGE_NAME PACKAGE
#endif
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION VERSION
#endif

enum enum_output_format { output_format__NULL = -1, output_format_arg_csxcad = 0, output_format_arg_pdf };

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * output_arg;	/**< @brief Output file. (default='-').  */
  char * output_orig;	/**< @brief Output file. original value given at command line.  */
  const char *output_help; /**< @brief Output file. help description.  */
  enum enum_output_format output_format_arg;	/**< @brief Output file format. (default='pdf').  */
  char * output_format_orig;	/**< @brief Output file format. original value given at command line.  */
  const char *output_format_help; /**< @brief Output file format. help description.  */
  char ** net_arg;	/**< @brief Import net. Repeat to import several nets. Default is importing all nets..  */
  char ** net_orig;	/**< @brief Import net. Repeat to import several nets. Default is importing all nets. original value given at command line.  */
  unsigned int net_min; /**< @brief Import net. Repeat to import several nets. Default is importing all nets.'s minimum occurreces */
  unsigned int net_max; /**< @brief Import net. Repeat to import several nets. Default is importing all nets.'s maximum occurreces */
  const char *net_help; /**< @brief Import net. Repeat to import several nets. Default is importing all nets. help description.  */
  char ** layer_arg;	/**< @brief Import layer. Repeat to import several layers. Default is importing all layers..  */
  char ** layer_orig;	/**< @brief Import layer. Repeat to import several layers. Default is importing all layers. original value given at command line.  */
  unsigned int layer_min; /**< @brief Import layer. Repeat to import several layers. Default is importing all layers.'s minimum occurreces */
  unsigned int layer_max; /**< @brief Import layer. Repeat to import several layers. Default is importing all layers.'s maximum occurreces */
  const char *layer_help; /**< @brief Import layer. Repeat to import several layers. Default is importing all layers. help description.  */
  double xmin_arg;	/**< @brief Crop pcb. Set lower bound of x coordinate..  */
  char * xmin_orig;	/**< @brief Crop pcb. Set lower bound of x coordinate. original value given at command line.  */
  const char *xmin_help; /**< @brief Crop pcb. Set lower bound of x coordinate. help description.  */
  double xmax_arg;	/**< @brief Crop pcb. Set upper bound of x coordinate..  */
  char * xmax_orig;	/**< @brief Crop pcb. Set upper bound of x coordinate. original value given at command line.  */
  const char *xmax_help; /**< @brief Crop pcb. Set upper bound of x coordinate. help description.  */
  double ymin_arg;	/**< @brief Crop pcb. Set lower bound of y coordinate..  */
  char * ymin_orig;	/**< @brief Crop pcb. Set lower bound of y coordinate. original value given at command line.  */
  const char *ymin_help; /**< @brief Crop pcb. Set lower bound of y coordinate. help description.  */
  double ymax_arg;	/**< @brief Crop pcb. Set upper bound of y coordinate..  */
  char * ymax_orig;	/**< @brief Crop pcb. Set upper bound of y coordinate. original value given at command line.  */
  const char *ymax_help; /**< @brief Crop pcb. Set upper bound of y coordinate. help description.  */
  double zmin_arg;	/**< @brief Crop pcb. Set lower bound of z coordinate..  */
  char * zmin_orig;	/**< @brief Crop pcb. Set lower bound of z coordinate. original value given at command line.  */
  const char *zmin_help; /**< @brief Crop pcb. Set lower bound of z coordinate. help description.  */
  double zmax_arg;	/**< @brief Crop pcb. Set upper bound of z coordinate..  */
  char * zmax_orig;	/**< @brief Crop pcb. Set upper bound of z coordinate. original value given at command line.  */
  const char *zmax_help; /**< @brief Crop pcb. Set upper bound of z coordinate. help description.  */
  double grid_arg;	/**< @brief Set output grid size. (default='10e-6').  */
  char * grid_orig;	/**< @brief Set output grid size. original value given at command line.  */
  const char *grid_help; /**< @brief Set output grid size. help description.  */
  double arc_precision_arg;	/**< @brief Set maximum difference between perfect arc and polygonal approximation. (default='0').  */
  char * arc_precision_orig;	/**< @brief Set maximum difference between perfect arc and polygonal approximation. original value given at command line.  */
  const char *arc_precision_help; /**< @brief Set maximum difference between perfect arc and polygonal approximation. help description.  */
  double clearance_arg;	/**< @brief Set default trace-to-plane clearance. (default='0.0002').  */
  char * clearance_orig;	/**< @brief Set default trace-to-plane clearance. original value given at command line.  */
  const char *clearance_help; /**< @brief Set default trace-to-plane clearance. help description.  */
  char ** flood_arg;	/**< @brief Flood layer with copper. Repeat to flood several layers. The value \"plane_layers\" floods all plane layers..  */
  char ** flood_orig;	/**< @brief Flood layer with copper. Repeat to flood several layers. The value \"plane_layers\" floods all plane layers. original value given at command line.  */
  unsigned int flood_min; /**< @brief Flood layer with copper. Repeat to flood several layers. The value \"plane_layers\" floods all plane layers.'s minimum occurreces */
  unsigned int flood_max; /**< @brief Flood layer with copper. Repeat to flood several layers. The value \"plane_layers\" floods all plane layers.'s maximum occurreces */
  const char *flood_help; /**< @brief Flood layer with copper. Repeat to flood several layers. The value \"plane_layers\" floods all plane layers. help description.  */
  double epsilonr_arg;	/**< @brief Set epsilon r of dielectric..  */
  char * epsilonr_orig;	/**< @brief Set epsilon r of dielectric. original value given at command line.  */
  const char *epsilonr_help; /**< @brief Set epsilon r of dielectric. help description.  */
  double loss_tangent_arg;	/**< @brief Set loss tangent of dielectric..  */
  char * loss_tangent_orig;	/**< @brief Set loss tangent of dielectric. original value given at command line.  */
  const char *loss_tangent_help; /**< @brief Set loss tangent of dielectric. help description.  */
  double bulk_resistivity_arg;	/**< @brief Set bulk resistivity of copper (in Ohm meter)..  */
  char * bulk_resistivity_orig;	/**< @brief Set bulk resistivity of copper (in Ohm meter). original value given at command line.  */
  const char *bulk_resistivity_help; /**< @brief Set bulk resistivity of copper (in Ohm meter). help description.  */
  int pcb_outline_flag;	/**< @brief Detailed board outline. (default=off).  */
  const char *pcb_outline_help; /**< @brief Detailed board outline. help description.  */
  int lossy_copper_flag;	/**< @brief Model copper as lossy. Default is modeling copper as perfect conductor. (default=off).  */
  const char *lossy_copper_help; /**< @brief Model copper as lossy. Default is modeling copper as perfect conductor. help description.  */
  int metal_3d_flag;	/**< @brief Model copper layers as 3D. Default is modeling metal as 2D sheet. (default=off).  */
  const char *metal_3d_help; /**< @brief Model copper layers as 3D. Default is modeling metal as 2D sheet. help description.  */
  double hue_arg;	/**< @brief Set PDF color hue. Range 0.0 to 1.0 (default='0.0').  */
  char * hue_orig;	/**< @brief Set PDF color hue. Range 0.0 to 1.0 original value given at command line.  */
  const char *hue_help; /**< @brief Set PDF color hue. Range 0.0 to 1.0 help description.  */
  double saturation_arg;	/**< @brief Set PDF color saturation. Range 0.0 to 1.0 (default='0.6').  */
  char * saturation_orig;	/**< @brief Set PDF color saturation. Range 0.0 to 1.0 original value given at command line.  */
  const char *saturation_help; /**< @brief Set PDF color saturation. Range 0.0 to 1.0 help description.  */
  double brightness_arg;	/**< @brief Set PDF color brightness. Range 0.0 to 1.0 (default='0.9').  */
  char * brightness_orig;	/**< @brief Set PDF color brightness. Range 0.0 to 1.0 original value given at command line.  */
  const char *brightness_help; /**< @brief Set PDF color brightness. Range 0.0 to 1.0 help description.  */
  int raw_flag;	/**< @brief Raw output. Do not join adjacent or overlapping copper. (default=off).  */
  const char *raw_help; /**< @brief Raw output. Do not join adjacent or overlapping copper. help description.  */
  unsigned int debug_min; /**< @brief Increase debugging level. Repeat for more detailed debugging.'s minimum occurreces */
  unsigned int debug_max; /**< @brief Increase debugging level. Repeat for more detailed debugging.'s maximum occurreces */
  const char *debug_help; /**< @brief Increase debugging level. Repeat for more detailed debugging. help description.  */
  const char *verbose_help; /**< @brief Print board summary. help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */
  unsigned int output_format_given ;	/**< @brief Whether output-format was given.  */
  unsigned int net_given ;	/**< @brief Whether net was given.  */
  unsigned int layer_given ;	/**< @brief Whether layer was given.  */
  unsigned int xmin_given ;	/**< @brief Whether xmin was given.  */
  unsigned int xmax_given ;	/**< @brief Whether xmax was given.  */
  unsigned int ymin_given ;	/**< @brief Whether ymin was given.  */
  unsigned int ymax_given ;	/**< @brief Whether ymax was given.  */
  unsigned int zmin_given ;	/**< @brief Whether zmin was given.  */
  unsigned int zmax_given ;	/**< @brief Whether zmax was given.  */
  unsigned int grid_given ;	/**< @brief Whether grid was given.  */
  unsigned int arc_precision_given ;	/**< @brief Whether arc-precision was given.  */
  unsigned int clearance_given ;	/**< @brief Whether clearance was given.  */
  unsigned int flood_given ;	/**< @brief Whether flood was given.  */
  unsigned int epsilonr_given ;	/**< @brief Whether epsilonr was given.  */
  unsigned int loss_tangent_given ;	/**< @brief Whether loss-tangent was given.  */
  unsigned int bulk_resistivity_given ;	/**< @brief Whether bulk-resistivity was given.  */
  unsigned int pcb_outline_given ;	/**< @brief Whether pcb-outline was given.  */
  unsigned int lossy_copper_given ;	/**< @brief Whether lossy-copper was given.  */
  unsigned int metal_3d_given ;	/**< @brief Whether metal-3d was given.  */
  unsigned int hue_given ;	/**< @brief Whether hue was given.  */
  unsigned int saturation_given ;	/**< @brief Whether saturation was given.  */
  unsigned int brightness_given ;	/**< @brief Whether brightness was given.  */
  unsigned int raw_given ;	/**< @brief Whether raw was given.  */
  unsigned int debug_given ;	/**< @brief Whether debug was given.  */
  unsigned int verbose_given ;	/**< @brief Whether verbose was given.  */

  char **inputs ; /**< @brief unnamed options (options without names) */
  unsigned inputs_num ; /**< @brief unnamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);

extern const char *cmdline_parser_output_format_values[];  /**< @brief Possible values for output-format. */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
